<?php
namespace Teknisa\FIN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\FIN\Factories\Ger38200ImportacaoContasPagarFactory;

class Ger38200ImportacaoContasPagarService {

    const RETORNO_VAZIO = null;
    const RETORNO_ERRO_SERV = 'Erro ao fazer requisição ';

    protected $entityManager;

    public function __construct(EntityManager $entityManager, Ger38200ImportacaoContasPagarFactory $ger38200ImportacaoContasPagarFactory){
        $this->entityManager = $entityManager;
        $this->ger38200ImportacaoContasPagarFactory = $ger38200ImportacaoContasPagarFactory;
    }
    
    public function importacaoContasPagar($dados) {
        $connection = $this->entityManager->getConnection();
        $connection->beginTransaction();
        try {
            
            // $idrequisicao  = $dados['IDREQUISICAO'];
            // //$dsrota        = $dados['IDREQUISICAO'];
            // //$cnpj          = $dados['CDCNPJ'];
            // $dtpagto       = $dados['DTPAGAMENTO'];
            // //$tppagto       = $dados['IDPAGAMENTO'];
            // //$tipomoviment  = $dados['IDREQUISICAO'];
            // $cdbanco       = $dados['IDBANCO'];
            // $cdtpconta     = $dados['CDTIPOCONTA'];
            // //$cnpjforn      = $dados['CDCNPJ'];
            // $dtcompetencia = $dados['DTCOMPETENCIA'];
            // //$seqnota       = $dados['IDREQUISICAO'];
            
            // // Verifica tipo de requisição | 1 - HcmServices / 2 - URL
            // if ($idrequisicao == '1') {
                    
            //     // Busca Parametrização Geral para Web Service HCM
            //     $paramgeral = $this->ger38200ImportacaoContasPagarFactory->buscaParamgeral();
                
            //     $stUrlHcm       = $paramgeral['DSURLHCM'];
            //     $stClientID     = $paramgeral['DSIDHCM'];
            //     $stClientSecret = $paramgeral['DSSECRETHCM'];
            //     $stToken        = $paramgeral['DSTOKENHCM'];
                
            //     if ($stUrlHcm and $stClientID and $stClientSecret) {
                    
            //     }else{
            //         throw new \Exception('Operação bloqueada. Dados de conexão do HCM não definidos.');
            //     }
            // }else{
            //     throw new \Exception('Operação bloqueada. Importação via URL não configurada.');
            // }
            
            
            $connection->commit();
        } catch (\Exception $e) {
            $connection->rollBack();
            throw $e;
        }
    }
    
    // public function conectaWebService(){
    //     try {
    //         // Definição de Fuso Horário
    //         date_default_timezone_set("America/Sao_Paulo");
            
    //         //Configurações para protocolo de segurança que é lido no header do Soap para todas as requisições
    //         $wsseNamespace = 'http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd';
    //         $security = new \SoapVar(
    //             array(new \SoapVar(
    //                 array(
    //                     new \SoapVar(self::$cdusuario, XSD_STRING, null, null, 'Username', $wsseNamespace),
    //                     new \SoapVar(self::$cdsenha, XSD_STRING, null, null, 'Password', $wsseNamespace)
    //                 ), 
    //                 SOAP_ENC_OBJECT, 
    //                 null, 
    //                 null, 
    //                 'UsernameToken', 
    //                 $wsseNamespace
    //             )), 
    //             SOAP_ENC_OBJECT
    //         );
    
    //         self::$header = new \SoapHeader($wsseNamespace, 'Security', $security, false);
    //     }catch(\Exception $e){
    //         echo($e->getMessage());
    //     }
    // }
    
    // /**
    //  * 
    //  */
    // public function checkAccessHCMServices($stUrlHcm, $stClientSecret, $stToken) {
        
    // }
    
    // /**
    //  * 
    //  */
    // public function requestTokenHCMServices($stUrlHcm, $stClientID, $stClientSecret) {
        
    // }
    
    // /**
    //  * 
    //  */
    // public function buscaDadosHCMServices(
    //     $stUrl, $stRota, $stClientSecret, $stToken, $stCnpj,
    //     $stDtpagamento, $stTppagamento, $stTpMoviment, $stCdBanco, $stCdTpConta, $stInscForn, $stDtCompetencia, $stSeqNota
    // ) {
    //     try{
    //          $headers = array();
            
    //          //Preparação dos parametros para o envio, obtendo a string json correspondente
    //          if ($stCdBanco)
    //               $stJsonParam = '{"requestType":"Row","row":{"CNPJ":"'+$stCnpj+'","DATA":"'+$stDtpagamento+'","MOVIMENTO":"'+$stTpMoviment+'","CDTPCTPAGAR":"'+$stCdTpConta+'","CNPJFORNECEDOR":"'+$stInscForn+'","DATACOMPETENCIA":"'+$stDtCompetencia+'"}}';
    //          else $stJsonParam = '{"requestType":"Row","row":{"CNPJ":"'+$stCnpj+'","DATA":"'+$stDtpagamento+'","MOVIMENTO":"'+$stTpMoviment+'","BANCO":"'+$stCdBanco+'","CDTPCTPAGAR":"'+$stCdTpConta+'","CNPJFORNECEDOR":"'+$stInscForn+'","DATACOMPETENCIA":"'+$stDtCompetencia+'"}}';
             
    //          //buffer contendo os parâmetros a serem enviados ao servidor
    //          $parametros = $stJsonParam;//VERIFICAR
            
    //         array_push($headers, 'OAuth-Token: '+$stToken, 'OAuth-SecretId: '+$stClientSecret);
            
    //          //Faz a requisição do serviço
    //          $stResposta = $this->webServiceRequest($stUrl+$stRota, 'application/json', strlen($stJsonParam), $headers, $parametros);
            
    //          //Se obteve resposta, processa-a
    //          if ( substr($stResposta, 0, strlen($this->RETORNO_ERRO_SERV)) == $this->RETORNO_ERRO_SERV ){
    //             $stMensagem = $stResposta;
    //          }elseif (($stResposta != RETORNO_VAZIO) and ($stResposta) {
    //                 $jsObjResponse = $stResposta;
    //                 if ($jsObjResponse->getMessages()){
    //                     $jsArrayMessages = $jsObjResponse.getJSONArray('messages');
    //                     $jsObjMessage    = $jsArrayMessages.getJSONObject(0);
    //                     $stMensagem      = $jsObjMessage.getString('message');
    //                 } else {
    //                     jsObjDataset := jsObjResponse.getJSONObject('dataset');
    //                     jsArrayPagamentos := jsObjDataset.getJSONArray('pagamentos');
    //                 }
            
    //             //Se a conversão ocorreu corretamente
    //             if EmptyString(stMensagem) then begin
            
    //               //Para cada elemento do array (que corresponde a um pagamento)
    //               i := 0;
    //               if (not(EmptyString(stSeqNota))) then begin
    //                   nrNota := StrToInt(stSeqNota);
    //               end;
    //               nrSeqConta := 0;
    //               while not jsArrayPagamentos.isNull(i) do begin
    //                   jsObjItem := jsArrayPagamentos.getJSONObject(i);
            
    //                   //Insere um novo item de pagamento
    //                   with cdsContasPagar do begin
    //                      Insert;
    //                      FieldByName('NRSEQCONTA').Value := nrSeqConta;
    //                      FieldByName('IDCHECK').Value := 'S';
    //                      FieldByName('NRINSCRICAO').Value := TratarCampos(jsObjItem.getString('cpf'));
    //                      FieldByName('DSNOME').Value := TratarCampos(jsObjItem.getString('nome'));
    //                      FieldByName('DTPAGTO').Value := TratarCampos(jsObjItem.getString('data'));
    //                      FieldByName('ORIGEM').Value := 'HCM';
    //                      valor1 :=       TratarCampos(jsObjItem.getString('valor'));
    //                      try
    //                         FieldByName('VALOR').Value := StringReplace(TratarCampos(jsObjItem.getString('valor')),'.',',',[]);
    //                      except
    //                         FieldByName('VALOR').Value := strToFloat(StringReplace(TratarCampos(jsObjItem.getString('valor')),'.',',',[]));
    //                      end;
            
    //                      if (EmptyString(stSeqNota)) then begin
    //                         FieldByName('NRNOTAFISC').Value := null;
    //                      end
    //                      else begin
    //                         FieldByName('NRNOTAFISC').Value := nrNota;
    //                      end;
            
    //                      //Insere os centros de custo, caso existam para o pagamento
    //                      if jsObjItem.has('filiais') then begin
    //                         jsObjFiliais := jsObjItem.getJSONObject('filiais');
    //                         for j := 0 to jsObjFiliais.keys.Count-1 do begin
    //                           jsObjCentCustos := jsObjFiliais.getJSONObject(jsObjFiliais.keys[j]);
    //                           for k := 0 to jsObjCentCustos.keys.Count-1 do begin
    //                               with cdsCentrosCusto do begin
    //                                  Insert;
    //                                  FieldByName('NRSEQCONTA').Value := nrSeqConta;
    //                                  FieldByName('CDFILIAL').Value := jsObjFiliais.keys[j];
    //                                  FieldByName('CDCENTCUST').Value := jsObjCentCustos.keys[k];
    //                                  try
    //                                   FieldByName('VRCENTCUST').Value := StringReplace(TratarCampos(jsObjCentCustos.getString(jsObjCentCustos.keys[k])),'.',',',[]);
    //                                  except
    //                                   FieldByName('VRCENTCUST').Value := strToFloat(StringReplace(TratarCampos(jsObjCentCustos.getString(jsObjCentCustos.keys[k])),'.',',',[]));
    //                                  end;
    //                                  Post;
    //                               end;
    //                           end;
    //                         end;
    //                      end
    //                      else begin
    //                         if jsObjItem.has('centrocustos') then begin
    //                           jsObjCentCustos := jsObjItem.getJSONObject('centrocustos');
    //                           for k := 0 to jsObjCentCustos.keys.Count-1 do begin
    //                               with cdsCentrosCusto do begin
    //                                  Insert;
    //                                  FieldByName('NRSEQCONTA').Value := nrSeqConta;
    //                                  FieldByName('CDCENTCUST').Value := jsObjCentCustos.keys[k];
    //                                   try
    //                                   FieldByName('VRCENTCUST').Value := StringReplace(TratarCampos(jsObjCentCustos.getString(jsObjCentCustos.keys[k])),'.',',',[]);
    //                                  except
    //                                   FieldByName('VRCENTCUST').Value := strToFloat(StringReplace(TratarCampos(jsObjCentCustos.getString(jsObjCentCustos.keys[k])),'.',',',[]));
    //                                  end;
    //                                  Post;
    //                               end;
    //                           end;
    //                         end;
    //                      end;
            
    //                      Post;
    //                   end;
    //                   i := i + 1;
    //                   nrNota := nrNota + 1;
    //                   nrSeqConta := nrSeqConta + 1;
    //               end;
    //             end;
    //          end;
    //         except
    //          on E : Exception do begin
    //             stMensagem := E.Message;
    //          end;
    //         end;
            
    //         Result := stMensagem;
    //         finally
    //         FreeAndNil(parametros);
    //         FreeAndNil(headers);
    //         end;
        
    // }
    
    
    // /**
    //  * 
    //  */
    // public function webServiceRequest() {
        
    // }
}