package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;

import java.util.concurrent.TimeUnit;

public class ContaCorrenteEditarPage extends PageBase {

    //Navegar até Conta Corrente
    By BotaoProcurar = By.xpath("/html/body/span/section/section/div[2]/section[1]/div/aside/div[1]/section/input");
    By Financeiro = By.xpath("/html/body/span/section/section/div[2]/section[2]/div/section/section[2]/section/header/div/div/ul/li[1]/label/a");
    By MENU = By.xpath("//div[@class='bars']");
    By ContaCorrente = By.xpath("/html/body/span/section/section/div[2]/section[1]/div/aside/div[2]/nav/ul/li[4]/span/span[3]");

    //Filtro

    By Banco = By.cssSelector("#NMBANCO");
    By OpcaoBanco = By.xpath("//*[@id=\"popup\"]/span/section/section/section/div/form/section[1]/div/div[1]/div[1]/div/div[3]/span[4]");

    By Agencia = By.cssSelector("#NMAGENCIA");
    By OpcaoAgencia = By.xpath("//*[@id=\"popup\"]/span/section/section/section/div/form/section[1]/div/div[1]/div[2]/div/div[3]/span[1]");


    By MaisCampos = By.xpath("//*[@id=\"popup\"]/span/section/section/section/div/form/section[2]/label/span[2]");

    By AplicarFiltro = By.cssSelector("#footer > div.zh-footer-right > ul > li > a > span");

    //Adiconar Conta
    By ClicarAdcionar = By.xpath("//*[@id=\"footer\"]/div[2]/ul/li/a/div");

    By CampoContaCorrente = By.cssSelector("#CDCONTCORR");

    By CampoBanco = By.cssSelector("#NMBANCO");
    By OpcaoCampoBanco = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[1]/div[1]/div/div[3]/span[4]");

    By CampoAgencia = By.cssSelector("#NMAGENCIA");
    By OpcaoCampoAgencia = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[1]/div[2]/div/div[3]/span[1]");

    By Tipo = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[2]/div[3]/div/div[2]/span");
    By OpcaoTipo = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[2]/div[3]/div/div[2]/ul/li[1]");

    By Descricao = By.cssSelector("#DSCONTCORR");

    By Empresa = By.cssSelector("#NMEMPRESA");
    By OpcaoEmpresa = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[4]/div/div/div[3]/span");

    By ContaContabil = By.cssSelector("#NMCONTCTBL");
    By OpcaoContaContabil = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[5]/div[1]/div/div[3]/span[1]");

    By ContaDesconto = By.cssSelector("#NMCCTBCAUCIO");
    By OpcaoContaDesconto = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[5]/div[2]/div/div[3]/span[2]");

    By ContaAtiva = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[5]/div[3]/div/div[2]");
    By OpcaoContaAtiva = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[5]/div[3]/div/div[2]/ul/li[1]");

    By Salvar = By.xpath("//*[@id=\"footer\"]/div[3]/ul/li/a/span");

    //Implantação de Saldo

    By OpcaoSim = By.xpath("/html/body/span/section/section/div[2]/aside[1]/aside/section/footer/button[1]/span");

    By Data = By.cssSelector("#DTSDOCCORR");
    By SaldoImplantado = By.cssSelector("#VRSDOIMPLA");

    By BotaoOk = By.xpath("/html/body/span/section/section/div[2]/aside[1]/aside/section/footer/button");

    //Evoluir Saldo

    By CheckBox = By.cssSelector("#grid-1547514630820780607600 > div.body > div > div > div.td.grid-checkbox-column.zh-side-column.fixed.zh-ripple-effect > span > svg > rect");

    By BotaoEvoluirSaldo= By.xpath("//*[@id=\"footer\"]/div[3]/ul/li/a/span");

    By DATAINICIAL = By.cssSelector("#DATAINICIAL");

    By ContaTeste = By.xpath("//*[@id=\"grid-1547514630820780607600\"]/div[2]/div/div/div[2]/span");
    By Editar= By.cssSelector("#footer > div.zh-footer-center > ul > li:nth-child(1) > a > div");

    By AbaDadosAdicionais = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[3]/section/header/div/div/ul/li[2]/label/a");

    //Descrição da Estrutura

    By CDREDUCONT = By.cssSelector("#CDREDUCONT");
    By NossoNumero = By.cssSelector("#DSNOSNUMCORR");
    By DigitoVerificador = By.cssSelector("#DSDACNOSNUMR");

    //Identificação da Conta

    By CodigoDoCedente = By.cssSelector("#CDCEDENTEBAN");
    By NomeDoCedente = By.cssSelector("#NMCEDENTEBAN");
    By IdentPagar = By.cssSelector("#CDIDPAGCONTCORR");
    By IdentReceber = By.cssSelector("#CDIDRECCONTCORR");

    //Faixa de Numeração do Nosso Número


    By TituloPreImpresso = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section[3]/div/div[1]/div[1]/div/div[2]");
    By OpcaoSimTituloImpresso = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section[3]/div/div[1]/div[1]/div/div[2]/ul/li[1]");

    By TituloCompleto = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section[3]/div/div[2]/div[1]/div/div[2]");
    By OpcaoTituloCompleto = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section[3]/div/div[2]/div[1]/div/div[2]/ul/li[1]");

    //Faixa de Numeração do Nosso Número
    By NRININOSNUMP =   By.cssSelector("#NRININOSNUMP");
    By NRFIMNOSNUMP =   By.cssSelector("#NRFIMNOSNUMP");

    By NRININOSNUMC =   By.cssSelector("#NRININOSNUMC");
    By NRFIMNOSNUMC =   By.cssSelector("#NRFIMNOSNUMC");

    //Valor para Transferência Eletrônica

    By ValorLimiteDeDOC = By.cssSelector("#VRLIMITEDOC");
    By CIP = By.cssSelector("#NRCIPCONTCORR");
    By Unidade =  By.cssSelector("#NMFILIAL");
    By OpcaoUnidade = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section[5]/div/div/div/div/div[3]/span[1]");

    //Valor para Transferência Eletrônica
    By ClientID = By.cssSelector("#CDCLIENTID");
    By ClientSecret = By.cssSelector("#CDCLIENTSECRET");

    //Aba Limite de Crédito

    By LimiteDeCredito = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[3]/section/header/div/div/ul/li[3]/label/a");
   //Credito Cheque

    By ControlaCredito = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section[1]/div/div/div[1]/div/div[2]");
    By OpcaoSimControlaCredito = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section[1]/div/div/div[1]/div/div[2]/ul/li[1]");
    By VRCTRCREDCHQ = By.cssSelector("#VRCTRCREDCHQ");

    //Crédito de Cobrança Descontada

    By ControlaCredito2 = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section[2]/div/div[1]/div[1]/div/div[2]");
    By OpcaoSimControlaCredito2 = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section[2]/div/div[1]/div[1]/div/div[2]/ul/li[1]");

    By VRCTRCOBDESC = By.cssSelector("#VRCTRCOBDESC");

    By VRPERCOBDESC = By.cssSelector("#VRPERCOBDESC");

    By VRLIMITCREDCCOR = By.cssSelector("#VRLIMITCREDCCOR");

    By AbaImplantacaoSaldo = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[3]/section/header/div/div/ul/li[4]/label/a");

    By DTSDOCCORR = By.cssSelector("#DTSDOCCORR");

    By VRSDOIMPLA = By.cssSelector("#VRSDOIMPLA");


    public void NavegarParaContaCorrente(String Procurar) {
        waitForElement(Financeiro);
        waitForElement(MENU);
        click(MENU);
        click(BotaoProcurar);
        clear(BotaoProcurar);
        sendKeys(BotaoProcurar, Procurar);
        click(ContaCorrente);
    }

    public void Filtro() {

        waitForElement(Banco);
        click(Banco);
        click(OpcaoBanco);

        click(Agencia);
        click(OpcaoAgencia);

        click(CDREDUCONT);
        click(MaisCampos);

        click(AplicarFiltro);
    }

    public void Editar(String DescricaoCCC) {
        waitForElement(ContaTeste);
        click(ContaTeste);

        click(Editar);

        click(Tipo);
        click(OpcaoTipo);

        click(Descricao);
        clear(Descricao);
        sendKeys(Descricao, DescricaoCCC);

        click(ContaContabil);
        click(OpcaoContaContabil);

        click(ContaDesconto);
        click(OpcaoContaDesconto);

        click(ContaAtiva);
        click(OpcaoContaAtiva);

        click(Salvar);

        click(AbaDadosAdicionais);

        click(Editar);

    }

    public void AbaDadosAdcionais(String CodigoReduzidoCCC, String CodNossoNumero, String CodDigitoVerificador, String CodCodigoDoCedente, String CodNomeDoCedente, String CodIdentPagar, String CodIdentReceber) {

        waitForElement(NossoNumero);

        click(CDREDUCONT);
        clear(CDREDUCONT);
        sendKeys(CDREDUCONT, CodigoReduzidoCCC);

        click(NossoNumero);
        clear(NossoNumero);
        sendKeys(NossoNumero, CodNossoNumero);

        click(DigitoVerificador);
        clear(DigitoVerificador);
        sendKeys(DigitoVerificador, CodDigitoVerificador);

        click(CodigoDoCedente);
        clear(CodigoDoCedente);
        sendKeys(CodigoDoCedente, CodCodigoDoCedente);

        click(NomeDoCedente);
        clear(NomeDoCedente);
        sendKeys(NomeDoCedente, CodNomeDoCedente);

        click(IdentPagar);
        clear(IdentPagar);
        sendKeys(IdentPagar, CodIdentPagar);

        click(IdentPagar);
        clear(IdentPagar);
        sendKeys(IdentPagar, CodIdentPagar);

        click(IdentReceber);
        clear(IdentReceber);
        sendKeys(IdentReceber, CodIdentReceber);

        //Faixa de Numeração do Nosso Número
        click(TituloPreImpresso);
        click(OpcaoSimTituloImpresso);

        click(TituloCompleto);
        click(OpcaoTituloCompleto);

    }

    public void FaixaDenumeracao(String VrNRININOSNUMP,String VrNRFIMNOSNUMP, String VrNRININOSNUMC, String VrNRFIMNOSNUMC, String VRLIMITEDOC, String NRCIPCONTCORR, String CDCLIENTID, String CDCLIENTSECRET ) {
        //Faixa de Numeração do Nosso Número

        click(NRININOSNUMP);
        clear(NRININOSNUMP);
        sendKeys(NRININOSNUMP, VrNRININOSNUMP);

        click(NRFIMNOSNUMP);
        clear(NRFIMNOSNUMP);
        sendKeys(NRFIMNOSNUMP, VrNRFIMNOSNUMP);

        click(NRININOSNUMC);
        clear(NRININOSNUMC);
        sendKeys(NRININOSNUMC, VrNRININOSNUMC);

        click(NRFIMNOSNUMC);
        clear(NRFIMNOSNUMC);
        sendKeys(NRFIMNOSNUMC, VrNRFIMNOSNUMC);

        //Valor para Transferência Eletrônica

        click(ValorLimiteDeDOC);
        clear(ValorLimiteDeDOC);
        sendKeys(ValorLimiteDeDOC, VRLIMITEDOC);

        click(CIP);
        clear(CIP);
        sendKeys(CIP, NRCIPCONTCORR);

        //Valor para Transferência Eletrônica

        click(Unidade);
        click(OpcaoUnidade);

        click(ClientID);
        clear(ClientID);
        sendKeys(ClientID, CDCLIENTID);

        click(ClientSecret);
        clear(ClientSecret);
        sendKeys(ClientSecret, CDCLIENTSECRET);

        click(Salvar);


    }

    public void AbaLimitedeCredito( String ValorDeCredito, String ValorDeCredito2, String PercAlerta, String ValorDeCredito3) {

        waitForElement(Editar);
        click(LimiteDeCredito);
        click(Editar);

        click(ControlaCredito);
        click(OpcaoSimControlaCredito);

        click(VRCTRCREDCHQ);
        clear(VRCTRCREDCHQ);
        sendKeys(VRCTRCREDCHQ, ValorDeCredito);

        click(ControlaCredito2);
        click(OpcaoSimControlaCredito2);

        click(VRCTRCOBDESC);
        clear(VRCTRCOBDESC);
        sendKeys(VRCTRCOBDESC, ValorDeCredito2);

        click(VRPERCOBDESC);
        clear(VRPERCOBDESC);
        sendKeys(VRPERCOBDESC, PercAlerta);

        click(VRLIMITCREDCCOR);
        clear(VRLIMITCREDCCOR);
        sendKeys(VRLIMITCREDCCOR, ValorDeCredito3);

        click(Salvar);





    }

    public void AbaImplantacaoDeSaldo(String Data, String ValorSaldoImplantado){
        waitForElement(AbaImplantacaoSaldo);
        click(AbaImplantacaoSaldo);
        click(ClicarAdcionar);

        click(DTSDOCCORR);
        clear(DTSDOCCORR);
        sendKeys(DTSDOCCORR, Data);

        click(VRSDOIMPLA);
        clear(VRSDOIMPLA);
        sendKeys(VRSDOIMPLA, ValorSaldoImplantado);

        click(Salvar);


    }




    public void AlertaUsuario() throws InterruptedException {
        this.driver.manage().timeouts().implicitlyWait(1, TimeUnit.MINUTES);
        driver.findElement(By.cssSelector("body > span > section > section > div.default-window > aside:nth-child(5) > aside > section > footer > button:nth-child(1)")).click();
    }

}
