package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.AgenciaExcluirFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.flows.AgenciaExcluirFlows;
import com.javaseleniumtemplate.pages.AgenciaExcluirPage;
import com.javaseleniumtemplate.pages.LoginPage;
import com.javaseleniumtemplate.pages.MainPage;
import com.javaseleniumtemplate.pages.AgenciaExcluirPage;
import org.testng.Assert;
import org.testng.annotations.Test;

public class AgenciaExcluir extends TestBase {

    // Objetos

    MainPage mainPage;
    LoginPage loginPage;
    MainFlows MainFlows;
    com.javaseleniumtemplate.flows.AgenciaExcluirFlows AgenciaExcluirFlows;
    com.javaseleniumtemplate.pages.AgenciaExcluirPage AgenciaExcluirPage;

    // Teste

    @Test
    public void efetuarLoginComSucesso() throws InterruptedException {

        //Objetos Instanciados

        mainPage = new MainPage();
        loginPage = new LoginPage();
        MainFlows = new MainFlows();
        AgenciaExcluirFlows = new AgenciaExcluirFlows();
        AgenciaExcluirPage = new AgenciaExcluirPage();

        // Dados - Login

        String Usuario = "operador24@AUTOMACAO_2184.com";
        String Senha = "apresentacao";
        String Agencia = "Agência";

        loginPage.preenhcerUsuario(Usuario);
        loginPage.preencherSenha(Senha);
        loginPage.clicarEmLogin();

        // Aguardar Botão de Confirmação(Alerta: Sim)
        AgenciaExcluirPage.AlertaUsuario();

        //Navegar até o Banco
        AgenciaExcluirPage.NavegarParaAgencia(Agencia);

        //Filtro
        AgenciaExcluirPage.Filtro();

        //Adicionar Agência
         AgenciaExcluirPage.AgenciaExcluir();

    }
}