package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.BancoFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.flows.BancoFlows;
import com.javaseleniumtemplate.pages.BancoPage;
import com.javaseleniumtemplate.pages.LoginPage;
import com.javaseleniumtemplate.pages.MainPage;
import com.javaseleniumtemplate.pages.BancoPage;
import org.testng.Assert;
import org.testng.annotations.Test;

public class Banco extends TestBase {

    // Objetos

    MainPage mainPage;
    LoginPage loginPage;
    MainFlows MainFlows;
    com.javaseleniumtemplate.flows.BancoFlows BancoFlows;
    com.javaseleniumtemplate.pages.BancoPage BancoPage;

    // Teste

    @Test
    public void efetuarLoginComSucesso() throws InterruptedException {

        //Objetos Instanciados

        mainPage = new MainPage();
        loginPage = new LoginPage();
        MainFlows = new MainFlows();
        BancoFlows = new BancoFlows();
        BancoPage = new BancoPage();

        // Dados - Login

        String Usuario = "operador24@AUTOMACAO_2184.com";
        String Senha = "apresentacao";

        String ValorCodigo = "5";
        String NomeBanco = "BANCOTESTE";
        String NumeroNomeBanco = "99999";
        String NumeroMascara = "999999";
        String NumeroCodigoDoBancoNaCameraDeCompensacao = "321";
        String NumeroBancoConveniado = "26";
        String NumeroDiasParaProrrogacao = "10";
        String ValorNumero = "104";

        String NumeroDiasParaProtesto1 = "10";
        String NumeroIdentPagar = "06";
        String NumeroIdentReceber = "07";

        String CodigoCobranca = "26";
        String NomeInstrucaCobranca = "Banco Teste";
        String NumeroBancoInstrucaCobranca = "101";
        String DescricaoDiretorioImportacao = "LocalHost";
        String DescricaoEmailDestinatario = "testando@hotmail.com";

        loginPage.preenhcerUsuario(Usuario);
        loginPage.preencherSenha(Senha);
        loginPage.clicarEmLogin();

        // Aguardar Botão de Confirmação(Alerta: Sim)
        BancoPage.AlertaUsuario();

        //Navegar até o Banco
        BancoPage.navegarParaBanco();

        //Adicionar conta Banco
        BancoPage.AdicionarConta(ValorCodigo, NomeBanco, NumeroNomeBanco, NumeroMascara, NumeroCodigoDoBancoNaCameraDeCompensacao, NumeroBancoConveniado, NumeroDiasParaProrrogacao);

        BancoPage.AbaCnab(ValorNumero, NumeroDiasParaProtesto1, NumeroIdentPagar, NumeroIdentReceber);

        BancoPage.OcorrenciaNoRetornoPagar();

        BancoPage.OcorrenciaNoRetornoReceber();

        BancoPage.InstrucoesCobranca(CodigoCobranca, NomeInstrucaCobranca, NumeroBancoInstrucaCobranca);

        BancoPage.AbaDDA(DescricaoDiretorioImportacao, DescricaoEmailDestinatario);

    }
}