package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.ContaContabilFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.flows.ParametroContabilFlows;
import com.javaseleniumtemplate.pages.ContaContabilPage;
import com.javaseleniumtemplate.pages.LoginPage;
import com.javaseleniumtemplate.pages.MainPage;
import com.javaseleniumtemplate.pages.ParametroContabilPage;
import org.testng.Assert;
import org.testng.annotations.Test;
public class ContaContabil extends TestBase {

    // Objetos

    MainPage mainPage;
    LoginPage loginPage;
    MainFlows MainFlows;
    com.javaseleniumtemplate.flows.ContaContabilFlows ContaContabilFlows;
    com.javaseleniumtemplate.pages.ContaContabilPage ContaContabilPage;

    @Test
    public void efetuarLoginComSucesso() throws InterruptedException {

        //Objetos Instanciados

        mainPage = new MainPage();
        loginPage = new LoginPage();
        MainFlows = new MainFlows();
        ContaContabilFlows = new ContaContabilFlows();
        ContaContabilPage = new ContaContabilPage();

        // Dados - Login

         String Usuario = "operador24@AUTOMACAO_2184.com";
         String Senha = "apresentacao";

        //String Usuario = "suporte_pebbian@teknisa.com";
        //String Senha = "Teknisa@2022";

        // Dados Criação Contas

        // Adicionar ATIVO
        String CodigoAtivoTeste = "6";
        String NomeAtivoTeste = "ATIVO teste";
        String CodigoReduzidoAtivoTeste = "6";

        // Adicionar Ativo Circulante
        String CodigoATIVOCIRCULANTE = "61";
        String NomeATIVOCIRCULANTE = "Ativo Circulante";
        String CodigoReduzidoATIVOCIRCULANTE = "61";

        // Adicionar DISPONIVEL
        String CodigoDISPONIVEL = "611";
        String NomeDISPONIVEL = "Disponível";
        String CodigoReduzidoDISPONIVEL = "611";

        // Adicionar NUMERARIOS
        String CodigoNUMERARIOS = "61101";
        String NomeNUMERARIOS = "Numerarios";
        String CodigoReduzidoNUMERARIOS = "61101";

        // Adicionar CAIXA
        String CodigoCAIXA = "61101001";
        String NomeCAIXA = "Caixa";
        String CodigoReduzidoCAIXA = "61101001";

        // Adicionar CAIXAGERAL
        String CodigoCAIXAGERAL = "6110100100001";
        String NomeCAIXAGERAL = "Caixa Geral";
        String CodigoReduzidoCAIXAGERAL = "6110100100001";

        // Adicionar ATIVO NAO CIRCULANTE
        String CodigoATIVONAOCIRCULANTE = "62";
        String NomeATIVONAOCIRCULANTE = "Ativo não Circulante";
        String CodigoReduzidoATIVONAOCIRCULANTE = "62";

        // Adicionar DUPLICATA A RECEBER
        String CodigoDUPLICATARECEBER = "621";
        String NomeDUPLICATARECEBER = "Duplicatas a Receber";
        String CodigoReduzidoDUPLICATARECEBER = "621";

        // Adicionar DUPLICATA A RECEBER LOJA
        String CodigoDUPLICATARECEBERLOJA = "62101";
        String NomeDUPLICATARECEBERLOJA = "Duplicatas a Receber Loja";
        String CodigoReduzidoDUPLICATARECEBERLOJA = "62101";

        // Adicionar DUPLICATA A RECEBER LOJA ABC
        String CodigoDUPLICATARECEBERLOJAABC = "62101001";
        String NomeDUPLICATARECEBERLOJAABC = "Duplicatas a Receber Loja ABC";
        String CodigoReduzidoDUPLICATARECEBERLOJAABC = "62101001";

        // Adicionar DUPLICATAS
        String CodigoDUPLICATAS = "6210100100001";
        String NomeDUPLICATAS= "Duplicatas a Receber";
        String CodigoReduzidoDUPLICATAS = "6210100100001";

        // Adicionar PASSIVO (Teste)
        String CodigoPASSIVOTeste = "7";
        String NomePASSIVOTeste = "PASSIVO (teste)";
        String CodigoReduzidoPASSIVOTeste = "7";

        // Adicionar PASSIVO CIRCULANTE(Teste)
        String CodigoPASSIVOCIRCULANTE= "71";
        String NomePASSIVOCIRCULANTE = "PASSIVO CIRCULANTE (teste)";
        String CodigoReduzidoPASSIVOCIRCULANTE = "71";

        // Adicionar EMPRÉSTIMOS E FINANCIAMENTOS
        String CodigoEMPRESTIMOSFINANCIAMENTOS= "711";
        String NomeEMPRESTIMOSFINANCIAMENTOS = "Empréstimos e Financiamentos";
        String CodigoReduzidoEMPRESTIMOSFINANCIAMENTOS = "711";

        // Adicionar EMPRESTIMOS NACIONAIS
        String CodigoEMPRESTIMOSNACIONAIS= "71101";
        String NomeEMPRESTIMOSNACIONAIS = "Emprestimos Nacionais";
        String CodigoReduzidoEMPRESTIMOSNACIONAIS = "71101";

        // Adicionar EMPRÉSTIMOS MINAS GERAIS
        String CodigoEMPRESTIMOSMINASGERAIS= "71101001";
        String NomeEMPRESTIMOSMINASGERAIS = "Emprestimos Minas Gerais";
        String CodigoReduzidoEMPRESTIMOSMINASGERAIS = "71101001";

        // Adicionar BANCO ITAU
        String CodigoBANCOITAU= "7110100100001";
        String NomeBANCOITAU = "Banco Itau";
        String CodigoReduzidoBANCOITAU = "7110100100001";

        // PASSIVO NÃO CIRCULANTE (LONGO PRAZO)
        String CodigoPASSIVONAOCIRCULANTE= "72";
        String NomePASSIVONAOCIRCULANTE = "Passivo não Circulante";
        String CodigoReduzidoPASSIVONAOCIRCULANTE = "72";

        // Adicionar EMPRÉSTIMOS E FINANCIAMENTOS LONGOPRAZO
        String CodigoEMPRESTIMOSFINANCIAMENTOSLONGOPRAZO= "721";
        String NomeEMPRESTIMOSFINANCIAMENTOSLONGOPRAZO = "Empréstimos e Financiamentos Longo Prazo";
        String CodigoReduzidoEMPRESTIMOSFINANCIAMENTOSLONGOPRAZO = "721";

        // Adicionar EMPRESTIMOS NACIONAIS LONGO PRAZO
        String CodigoEMPRESTIMOSNACIONAISLONGOPRAZO= "72101";
        String NomeEMPRESTIMOSNACIONAISLONGOPRAZO = "Emprestimos Nacionais Longo Prazo";
        String CodigoReduzidoEMPRESTIMOSNACIONAISLONGOPRAZO = "72101";

        // Adicionar EMPRÉSTIMOS MINAS GERAIS LONGO PRAZO
        String CodigoEMPRESTIMOSMINASGERAISLONGOPRAZO= "72101001";
        String NomeEMPRESTIMOSMINASGERAISLONGOPRAZO = "Emprestimos Minas Gerais Longo Prazo";
        String CodigoReduzidoEMPRESTIMOSMINASGERAISLONGOPRAZO = "71101001";

        // Adicionar BANCO ITAU LONGO PRAZO
        String CodigoBANCOITAULONGOPRAZO = "7210100100001";
        String NomeBANCOITAULONGOPRAZO = "Banco Itau Longo Prazo";
        String CodigoReduzidoBANCOITAULONGOPRAZO = "7210100100001";

        // Adicionar RECEITAS (Teste)
        String CodigoRECEITAS = "8";
        String NomeRECEITAS = "RECEITAS (Teste)";
        String CodigoReduzidoRECEITAS = "8";

        // Adicionar RECEITAS OPERACIONAIS GERAIS
        String CodigoRECEITASOPERACIONAISGERAIS = "81";
        String NomeRECEITASOPERACIONAISGERAIS = "Receitas Operacionais Gerais";
        String CodigoReduzidoRECEITASOPERACIONAISGERAIS = "81";

        // Adicionar RECEITAS OPERACIONAIS
        String CodigoRECEITASOPERACIONAIS = "811";
        String NomeRECEITASOPERACIONAIS = "Receitas Operacionais";
        String CodigoReduzidoRECEITASOPERACIONAIS = "811";

        // Adicionar RECEITA BRUTA DE VENDAS E SERVIÇOS
        String CodigoRECEITABRUTA = "81101";
        String NomeRECEITABRUTA = "Receita Bruta de Vendas e Serviços";
        String CodigoReduzidoRECEITABRUTA = "81101";

        // Adicionar RECEITA BRUTA DE VENDAS
        String CodigoRECEITABRUTAVENDAS = "81101001";
        String NomeRECEITABRUTAVENDAS = "Receita Bruta de Vendas";
        String CodigoReduzidoRECEITABRUTAVENDAS = "81101001";

        // Adicionar Adcionar Venda de prod. no mercado interno
        String CodigoVENDAPRODUTO = "8110100100001";
        String NomeVENDAPRODUTO = "Venda de prod. no mercado interno";
        String CodigoReduzidoVENDAPRODUTO = "8110100100001";

        String CodigoCUSTODESPESAS = "9";
        String NomeCUSTODESPESAS = "CUSTOS e DESPESAS (Teste)";
        String CodigoReduzidoCUSTODESPESAS = "9";

        // Adcionar CUSTO DOS PRODUTOS E SERVIÇOS VENDIDOS
        String CodigoCUSTOPRODUTOSSERVIÇOS = "91";
        String NomeCUSTOPRODUTOSSERVIÇOS = "Custo dos Produtos e Serviços Vendidos";
        String CodigoReduzidoCUSTOPRODUTOSSERVIÇOS = "91";

        // Adcionar CUSTO DOS PRODUTOS VENDIDOS (1)
        String CodigoCUSTOPRODUTOSVENDIDOS = "911";
        String NomeCUSTOPRODUTOSVENDIDOS = "Custo dos Produtos Vendidos";
        String CodigoReduzidoCUSTOPRODUTOSVENDIDOS = "911";

        // Adcionar CUSTO DOS PRODUTOS VENDIDOS (2)
        String CodigoCUSTOPRODUTOSVENDIDOSS = "91101";
        String NomeCUSTOPRODUTOSVENDIDOSS = "Custo dos Produtos Vendidos";
        String CodigoReduzidoCUSTOPRODUTOSVENDIDOSS = "91101";

        // Adcionar CUSTO DOS PRODUTOS VENDIDOS (3)
        String CodigoCUSTOPRODUTOSVENDIDOSSS = "91101001";
        String NomeCUSTOPRODUTOSVENDIDOSSS = "Custo dos Produtos Vendidos";
        String CodigoReduzidoCUSTOPRODUTOSVENDIDOSSS = "91101001";

        // Adcionar CUSTO DOS PRODUTOS VENDIDOS FABRICA
        String CodigoCUSTOPRODUTOSVENDIDOSFABRICA = "9110100100001";
        String NomeCUSTOPRODUTOSVENDIDOSFABRICA = "Custo dos Produtos Vendidos Fabrica";
        String CodigoReduzidoCUSTOPRODUTOSVENDIDOSFABRICA = "9110100100001";

        loginPage.preenhcerUsuario(Usuario);
        loginPage.preencherSenha(Senha);
        loginPage.clicarEmLogin();

        // Aguardar Botão de Confirmação(Alerta: Sim)
        ContaContabilPage.AlertaUsuario();

        // Navegar até Conta Contábil
        MainFlows.navegarContaContabil();

        //-----------------------------------------//-------------------------------------------------------------------------//
        // Adcionar Conta Sintetica ATIVO
        ContaContabilPage.AdicionarAtivoTeste(CodigoAtivoTeste, NomeAtivoTeste, CodigoReduzidoAtivoTeste);

        // Adcionar ATIVO CIRCULANTE
        ContaContabilPage.AdicionarATIVOCIRCULANTE(CodigoATIVOCIRCULANTE, NomeATIVOCIRCULANTE, CodigoReduzidoATIVOCIRCULANTE);

        // Adcionar ATIVO NÃO CIRCULANTE
        //ContaContabilPage.AdicionarATIVONAOCIRCULANTE(CodigoATIVONAOCIRCULANTE, NomeATIVONAOCIRCULANTE, CodigoReduzidoATIVONAOCIRCULANTE);

        // Adcionar Disponivel
        ContaContabilPage.AdicionarDISPONIVEL(CodigoDISPONIVEL, NomeDISPONIVEL, CodigoReduzidoDISPONIVEL);

        // Adcionar NUMERARIOS
        ContaContabilPage.AdicionarNUMERARIOS(CodigoNUMERARIOS, NomeNUMERARIOS, CodigoReduzidoNUMERARIOS);

        // Adcionar CAIXA
        ContaContabilPage.AdicionarCAIXA(CodigoCAIXA, NomeCAIXA, CodigoReduzidoCAIXA);

        // Adcionar CAIXA GERAL
        ContaContabilPage.AdicionarCAIXAGERAL(CodigoCAIXAGERAL, NomeCAIXAGERAL, CodigoReduzidoCAIXAGERAL);

        // Adcionar ATIVO NÃO CIRCULANTE
        //ContaContabilPage.AdicionarATIVONAOCIRCULANTE(CodigoATIVONAOCIRCULANTE, NomeATIVONAOCIRCULANTE, CodigoReduzidoATIVONAOCIRCULANTE);

        // Adcionar DUPLICATA A RECEBER
        //ContaContabilPage.AdicionarDUPLICATARECEBER(CodigoDUPLICATARECEBER, NomeDUPLICATARECEBER, CodigoReduzidoDUPLICATARECEBER);

        // Adcionar DUPLICATA A RECEBER LOJA
        //ContaContabilPage.AdicionarDUPLICATARECEBERLOJA(CodigoDUPLICATARECEBERLOJA, NomeDUPLICATARECEBERLOJA, CodigoReduzidoDUPLICATARECEBERLOJA);

        // Adcionar DUPLICATA A RECEBER LOJA ABC
        //ContaContabilPage.AdicionarDUPLICATARECEBERLOJAABC(CodigoDUPLICATARECEBERLOJAABC, NomeDUPLICATARECEBERLOJAABC, CodigoReduzidoDUPLICATARECEBERLOJAABC);

        // Adcionar DUPLICATAS
        //ContaContabilPage.AdicionarDUPLICATAS(CodigoDUPLICATAS, NomeDUPLICATAS, CodigoReduzidoDUPLICATAS);

        //-----------------------------------------//-------------------------------------------------------------------------//

        // Adcionar Conta Sintetica PASSIVO
        //ContaContabilPage.AdicionarPASSIVOTeste(CodigoPASSIVOTeste, NomePASSIVOTeste, CodigoReduzidoPASSIVOTeste);

        // Adcionar PASSIVO CIRCULANTE
        //ContaContabilPage.AdicionarPASSIVOCIRCULANTE(CodigoPASSIVOCIRCULANTE, NomePASSIVOCIRCULANTE, CodigoReduzidoPASSIVOCIRCULANTE);

        // Adcionar EMPRÉSTIMOS E FINANCIAMENTOS
        //ContaContabilPage.AdicionarEMPRESTIMOSFINANCIAMENTOS(CodigoEMPRESTIMOSFINANCIAMENTOS, NomeEMPRESTIMOSFINANCIAMENTOS, CodigoReduzidoEMPRESTIMOSFINANCIAMENTOS);

        // Adcionar EMPRÉSTIMOS NACIONAIS
        //ContaContabilPage.AdicionarEMPRESTIMOSNACIONAIS(CodigoEMPRESTIMOSNACIONAIS, NomeEMPRESTIMOSNACIONAIS, CodigoEMPRESTIMOSNACIONAIS);

        // Adcionar EMPRÉSTIMOS NACIONAIS
        //ContaContabilPage.AdicionarEMPRESTIMOSMINASGERAIS(CodigoEMPRESTIMOSMINASGERAIS, NomeEMPRESTIMOSMINASGERAIS, CodigoEMPRESTIMOSMINASGERAIS);

        // Adcionar Banco Itaú S/A -
        //ContaContabilPage.AdicionarBANCOITAU(CodigoBANCOITAU, NomeBANCOITAU, CodigoReduzidoBANCOITAU);

        // Adcionar PASSIVO NÃO CIRCULANTE (PASSIVO EXIGÍVEL A LONGO PRAZO)
        //ContaContabilPage.AdicionarPASSIVONAOCIRCULANTE(CodigoPASSIVONAOCIRCULANTE, NomePASSIVONAOCIRCULANTE, CodigoReduzidoPASSIVONAOCIRCULANTE);

        // Adcionar EMPRÉSTIMOS E FINANCIAMENTOS LONGO PRAZO
        //ContaContabilPage.AdicionarEMPRESTIMOSFINANCIAMENTOSLONGOPRAZO(CodigoEMPRESTIMOSFINANCIAMENTOSLONGOPRAZO, NomeEMPRESTIMOSFINANCIAMENTOSLONGOPRAZO, CodigoReduzidoEMPRESTIMOSFINANCIAMENTOSLONGOPRAZO);

        // Adcionar EMPRÉSTIMOS NACIONAIS LONGO PRAZO
        //ContaContabilPage.AdicionarEMPRESTIMOSNACIONAISLONGOPRAZO(CodigoEMPRESTIMOSNACIONAISLONGOPRAZO, NomeEMPRESTIMOSNACIONAISLONGOPRAZO, CodigoEMPRESTIMOSNACIONAISLONGOPRAZO);

         // Adcionar EMPRÉSTIMOS MINAS GERAIS LONGOPRAZO
         //ContaContabilPage.AdicionarEMPRESTIMOSMINASGERAISLONGOPRAZO(CodigoEMPRESTIMOSMINASGERAISLONGOPRAZO, NomeEMPRESTIMOSMINASGERAISLONGOPRAZO, CodigoEMPRESTIMOSMINASGERAISLONGOPRAZO);

        // Adcionar Banco Itaú S/A - LONGOPRAZO
         //ContaContabilPage.AdicionarBANCOITAULONGOPRAZO(CodigoBANCOITAULONGOPRAZO, NomeBANCOITAULONGOPRAZO, CodigoReduzidoBANCOITAULONGOPRAZO);
        //-----------------------------------------//-------------------------------------------------------------------------//

        // Adcionar Conta Sintetica RECEITAS
        //ContaContabilPage.AdicionarRECEITASTeste(CodigoRECEITAS, NomeRECEITAS, CodigoReduzidoRECEITAS);

        // Adcionar RECEITAS OPERACIONAIS GERAIS
        //ContaContabilPage.AdicionarRECEITASOPERACIONAISGERAIS(CodigoRECEITASOPERACIONAISGERAIS, NomeRECEITASOPERACIONAISGERAIS, CodigoReduzidoRECEITASOPERACIONAISGERAIS);

        // Adcionar RECEITAS OPERACIONAIS
        //ContaContabilPage.AdicionarRECEITASOPERACIONAIS(CodigoRECEITASOPERACIONAIS, NomeRECEITASOPERACIONAIS, CodigoReduzidoRECEITASOPERACIONAIS);

        // Adcionar RECEITA BRUTA DE VENDAS E SERVIÇOS
        //ContaContabilPage.AdicionarRECEITABRUTA(CodigoRECEITABRUTA, NomeRECEITABRUTA, CodigoReduzidoRECEITABRUTA);

        // Adcionar RECEITA BRUTA DE VENDAS
        //ContaContabilPage.AdicionarRECEITABRUTAVENDAS(CodigoRECEITABRUTAVENDAS, NomeRECEITABRUTAVENDAS, CodigoReduzidoRECEITABRUTAVENDAS);

        // Adcionar Venda de prod. no mercado interno
        //ContaContabilPage.AdicionarVENDAPRODUTO(CodigoVENDAPRODUTO, NomeVENDAPRODUTO, CodigoReduzidoVENDAPRODUTO);

        // Adicionar  CUSTOS e DESPESAS (Teste)

        //-----------------------------------------//-------------------------------------------------------------------------//

        // Adcionar Conta Sintetica CUSTOS e DESPESAS (Teste)
        //ContaContabilPage.AdicionarCustosDespesasTeste(CodigoCUSTODESPESAS, NomeCUSTODESPESAS, CodigoReduzidoCUSTODESPESAS);;

        // Adcionar CUSTO DOS PRODUTOS E SERVIÇOS VENDIDOS
        //ContaContabilPage.AdicionarCUSTOPRODUTOSSERVICOSVENDIDOS(CodigoCUSTOPRODUTOSSERVIÇOS, NomeCUSTOPRODUTOSSERVIÇOS, CodigoReduzidoCUSTOPRODUTOSSERVIÇOS);

        // Adcionar CUSTO DOS PRODUTOS VENDIDOS (1)
        //ContaContabilPage.AdicionarCUSTOPRODUTOSVENDIDOS(CodigoCUSTOPRODUTOSVENDIDOS, NomeCUSTOPRODUTOSVENDIDOS, CodigoReduzidoCUSTOPRODUTOSVENDIDOS);

        // Adcionar CUSTO DOS PRODUTOS VENDIDOS (2)
        //ContaContabilPage.AdicionarCUSTOPRODUTOSVENDIDOSS(CodigoCUSTOPRODUTOSVENDIDOSS, NomeCUSTOPRODUTOSVENDIDOSS, CodigoReduzidoCUSTOPRODUTOSVENDIDOSS);

        // Adcionar CUSTO DOS PRODUTOS VENDIDOS (3)
        //ContaContabilPage.AdicionarCUSTOPRODUTOSVENDIDOSSS(CodigoCUSTOPRODUTOSVENDIDOSSS, NomeCUSTOPRODUTOSVENDIDOSSS, CodigoReduzidoCUSTOPRODUTOSVENDIDOSSS);

        // Adcionar CUSTO DOS PRODUTOS VENDIDOS FABRICA
        //ContaContabilPage.AdicionarCUSTOPRODUTOSVENDIDOSFABRICA(CodigoCUSTOPRODUTOSVENDIDOSFABRICA, NomeCUSTOPRODUTOSVENDIDOSFABRICA, CodigoReduzidoCUSTOPRODUTOSVENDIDOSFABRICA);

    }
}

