package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.ContaCorrenteEditarFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.flows.ContaCorrenteEditarFlows;
import com.javaseleniumtemplate.pages.ContaCorrenteEditarPage;
import com.javaseleniumtemplate.pages.LoginPage;
import com.javaseleniumtemplate.pages.MainPage;
import com.javaseleniumtemplate.pages.ContaCorrenteEditarPage;
import org.testng.Assert;
import org.testng.annotations.Test;

public class ContaCorrenteEditar extends TestBase {

    // Objetos

    MainPage mainPage;
    LoginPage loginPage;
    MainFlows MainFlows;
    com.javaseleniumtemplate.flows.ContaCorrenteEditarFlows ContaCorrenteEditarFlows;
    com.javaseleniumtemplate.pages.ContaCorrenteEditarPage ContaCorrenteEditarPage;

    // Teste

    @Test
    public void efetuarLoginComSucesso() throws InterruptedException {

        //Objetos Instanciados

        mainPage = new MainPage();
        loginPage = new LoginPage();
        MainFlows = new MainFlows();
        ContaCorrenteEditarFlows = new ContaCorrenteEditarFlows();
        ContaCorrenteEditarPage = new ContaCorrenteEditarPage();

        // Dados - Login

        String Usuario = "operador24@AUTOMACAO_2184.com";
        String Senha = "apresentacao";

        //Navegar
        String Procurar = "Conta Corrente";
        String CodigoReduzidoCCC = "Z66";
        String NumeroCCC = "1234567";

        String DescricaoCCC = "Conta usada para Teste";

        String DTSDOCCORR = "01/01/2023";
        String VRSDOIMPLA = "1000";

        String DATAINICIALEvolucao = "01/01/2023";

        String CodNossoNumero = "9876543210";
        String CodDigitoVerificador = "26";
        String CodCodigoDoCedente = "665";
        String CodNomeDoCedente = "Brasil";
        String CodIdentPagar = "9090190";
        String CodIdentReceber = "9080700";
        //Faixa de Numeração do Nosso Número
        String VrNRININOSNUMP = "1";
        String VrNRFIMNOSNUMP = "101";
        String VrNRININOSNUMC = "1";
        String VrNRFIMNOSNUMC = "201";

        //Valor para Transferência Eletrônica

        String VRLIMITEDOC = "1000";
        String NRCIPCONTCORR = "1000";

        //Valor para Transferência Eletrônica

        String CDCLIENTID = "100";
        String CDCLIENTSECRET = "99";

        String ValorDeCredito = "999";

        String ValorDeCredito2 = "998";

        String PercAlerta = "5";

        String ValorDeCredito3 = "997";

        //Aba Implantação de Saldo

        String Data = "01/01/2023";
        String ValorSaldoImplantado = "1000";




        loginPage.preenhcerUsuario(Usuario);
        loginPage.preencherSenha(Senha);
        loginPage.clicarEmLogin();

        // Aguardar Botão de Confirmação(Alerta: Sim)
        ContaCorrenteEditarPage.AlertaUsuario();

        //Navegar até ContaCorrente
        ContaCorrenteEditarPage.NavegarParaContaCorrente(Procurar);

        //Filtro
        ContaCorrenteEditarPage.Filtro();

        //Editar Conta
        ContaCorrenteEditarPage.Editar(DescricaoCCC);

        //Aba Dados Adicionais
        ContaCorrenteEditarPage.AbaDadosAdcionais(CodigoReduzidoCCC, CodNossoNumero, CodDigitoVerificador, CodCodigoDoCedente, CodNomeDoCedente, CodIdentPagar, CodIdentReceber);

        //Faixa de Numeração do Nosso Número
        ContaCorrenteEditarPage. FaixaDenumeracao(VrNRININOSNUMP, VrNRFIMNOSNUMP, VrNRININOSNUMC, VrNRFIMNOSNUMC,VRLIMITEDOC,NRCIPCONTCORR, CDCLIENTID, CDCLIENTSECRET );

        //Aba Limite de Crédito
        ContaCorrenteEditarPage.AbaLimitedeCredito(ValorDeCredito, ValorDeCredito2, PercAlerta, ValorDeCredito3);

        //Aba Implantação de Saldo
        ContaCorrenteEditarPage.AbaImplantacaoDeSaldo(Data, ValorSaldoImplantado);


    }
}