package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;

public class ApuracaoImpostoCOFINSPage extends PageBase {

    // Fitro

    By mensagemApuraImp = By.xpath("//*[.='OK']");
    By filtroApuracao = By.xpath("//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By filtroApuracaoFederal = By.xpath("//*[@data-value='0']");
    By filtroEmpresa = By.xpath("//span[@class=\"zh-icon zh-icon-search zh-icon-no-border\"]");
    By filtroEmpresaHela = By.xpath("//div[@data-ng-repeat=\"rowIndex in filtered = controller.getVisibleRowCount()\"]");
    By filtroImposto = By.xpath("//*[@id=\"DSIMPOSTONFE\"]//*[@class=\"zh-icon zh-icon-search zh-icon-no-border\"]");
    By filtroImpostoIpi = By.xpath("//div[@class=\"td zh-standard-column  grid-align-left\"]");


    By filtroAplicarFiltro = By.xpath("//span[text() = 'Aplicar filtro'][1]");

    By adicionarMapa = By.xpath("//a[@data-zh-title-tooltip = 'Adicionar (F2)']");

    By nomeMapaIpi = By.id("NMMAPAAPUR");

    By salvarMapaapurac = By.xpath("//div[@id='footer']//span[text() = 'Salvar']");

    By selecionarmapaapurac = By.xpath("//span[text() = 'Apuração de IPI']");

    By acoes = By.xpath("//span[@data-zh-bind-translate=\"'Actions'\"]");

    By apurar = By.xpath("//span[text() = 'Apurar']");

    By MensagemOk = By.xpath("//span[@data-ng-bind=\"button.label\"]");

    By excluir = By.xpath("//*[@data-zh-title-tooltip=\"Excluir (Ctrl + D)\"]");

    By sim = By.xpath("//span[text() = 'Sim']");

    By loadingWait = By.xpath("//*[@class='zh-background-loading ng-scope']//span[@class='zh-loading-icon']");

    By AbaDeDetalhamento = By.xpath("//*[text() = 'Detalhamento']");

    By BotaoAjusteAcrescimo = By.xpath("//div[@id=\"span-field-CONTABAJUSTCREDACRES\"]//span[@class=\"zh-icon zh-icon-list\"]");

    By BotaoAjusteAcrescimoDeb = By.xpath("//*[@data-zh-id=\"632245607678299193837\"]//span[@class=\"zh-icon zh-icon-list\"]");

    By Adicionar = By.xpath("//div[@class=\"zh-test-box\"]");

    By filtroCodigoAjuste = By.xpath("//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid open\"]");

    By CodigoAjuste = By.xpath("//*[@class=\"list zh-new-select-list\"]//*[text() = '01 - Ajuste Oriundo de Ação Judicial']");

    By filtroTipoCredito = By.xpath("//div[@data-zh-id=\"63224560740363300551133\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");

    By TipoCredito = By.xpath("//*[@class=\"list zh-new-select-list\"]//*[text() = '101']");

    By filtroRegimeApuracao = By.xpath("//div[@data-zh-id=\"632245607550537751134\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");

    By RegimeApuracao = By.xpath("//*[@class=\"list zh-new-select-list\"]//*[text() = 'Não Cumulativo']");

    By VrAjusteAcresc = By.xpath("//*[@zh-id=\"63224560736661459021132\"]");

    By Salvar = By.xpath("//span[text() = 'Salvar']");

    By Voltar = By.xpath("//span[text() = 'Voltar']");

    By filtroAjustBaseCal = By.xpath("//div[@data-zh-id=\"632245607623140216821\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");

    By AjusteBaseCal = By.xpath("//*[@class=\"list zh-new-select-list\"]//*[text() = '01 - Vendas canceladas de receitas tributadas em períodos anteriores']");

    By filtroCST = By.xpath("//div[@data-zh-id=\"63224560724325325011135\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");

    By CST = By.xpath("//*[@class=\"list zh-new-select-list\"]//*[text() = '01']");

    By valorBaseDeCalc = By.xpath("//*[@zh-id=\"6322456072265280585823\"]");

    By NumProcesso = By.xpath("//*[@zh-id=\"63224560734905934221136\"]");

    By descricaoAjuste = By.xpath("//*[@zh-id=\"63224560738448068991137\"]");

    By dataDebitoSaidas = By.xpath("//*[@class=\"input-text zh-calendar-input mousetrap ng-pristine ng-valid ng-touched\"]");

    By FiltroContaContabil = By.xpath("//div[@class=\"zh-select-multiple zh-select-autocomplete mousetrap zh-field-CDCONTCTBL zh-text-align-left\"]//span[@zh-icon=\"no-border search\"]");

    By ContaContabil = By.xpath("//span[text() = '4120100100002']");

    By FiltroEstabelecimento = By.xpath("//div[@class=\"zh-select-multiple zh-select-autocomplete mousetrap zh-field-CDFILIAL zh-text-align-left\"]//span[@zh-icon=\"no-border search\"]");

    By Estabelecimento = By.xpath("//span[text() = '0001']");

    By NrRecibo = By.xpath("//*[@zh-id=\"632245607143409862834\"]");

    By AbaApuracaoDeImposto = By.xpath("//*[@class=\"zh-tab-cell\"]//*[text() = 'Apuração de Imposto']");


    public void clicarOkMsgApuraImp(){
        click(mensagemApuraImp);
    }

    public void clicarEmTipodeapuracao(){
        click(filtroApuracao); click(filtroApuracaoFederal);
    }

    public void clicarEmEmpresa(){
        click(filtroEmpresa); click(filtroEmpresaHela);
    }

    public void clicarEmImposto(){
        click(filtroImposto); click(filtroImpostoIpi);
    }

    public void clicarAplicarFiltro(){
        click(filtroAplicarFiltro);
    }

    public void clicarAdicionarMapa() {
        waitForVisibilityOfElementLocated(loadingWait);
        waitForInvisibilityOfElementLocated(loadingWait);
        click(adicionarMapa);
    }

    public void preencherNomedomapa(String nomedomapa){
        click(nomeMapaIpi); sendKeys(nomeMapaIpi, nomedomapa);
    }

    public void clicarsalvarMapa(){
        click(salvarMapaapurac);
    }

    public void clicarEmMapaApuracao(){
        click(selecionarmapaapurac);
    }

    public void clicarEmAcoes(){
        click(acoes);
    }

    public void clicarEmApurar(){
        click(apurar);
    }

    public void clicarOk(){
        click(MensagemOk);
    }

    public void clicarEmExcluir(){
        click(excluir);
    }

    public void clicarEmSim(){
        click(sim);
    }

    public void clicarAbaDetalhamento(){
        click(AbaDeDetalhamento);
    }

    public void clicarBotaoAjusteAcrescimo(){
        click(BotaoAjusteAcrescimo);
    }

    public void clicarEmAdicionar(){
        click(Adicionar);
    }

    public void clicarEmCodigoAjuste(){
        click(filtroCodigoAjuste); click(CodigoAjuste);
    }

    public void clicarEmTipoCredito(){
        click(filtroTipoCredito); click(TipoCredito);
    }

    public void clicarEmRegimeApuracao(){
        click(filtroRegimeApuracao); click(RegimeApuracao);
    }

    public void preencherValorAjusAcresc(String valorAjusteAcrescimo){
        click(VrAjusteAcresc); sendKeys(VrAjusteAcresc, valorAjusteAcrescimo);
    }

    public void clicarEmSalvar(){
        click(Salvar);
    }

    public void clicarEmVoltar(){
        click(Voltar);
    }

    public void clicarEmAjusteBaseCalculo(){
        click(filtroAjustBaseCal); click(AjusteBaseCal);
    }

    public void clicarBotaoAjusteAcrescimoDeb(){
        click(BotaoAjusteAcrescimoDeb);
    }

    public void clicarEmCSTAjusteDeb(){
        click(filtroCST); click(CST);
    }

    public void preencherValorBaseDeCalculo(String valorBaseCalculo){
        click(valorBaseDeCalc); sendKeys(valorBaseDeCalc, valorBaseCalculo);
    }

    public void preencherNumeroDProcesso(String NumeroDoProcesso){
        click(NumProcesso); sendKeys(NumProcesso, NumeroDoProcesso);
    }

    public void preencherDescricaoDoAjuste(String DescricaoAjuste){
        click(descricaoAjuste); sendKeys(descricaoAjuste, DescricaoAjuste);
    }

    public void preencherDataDebitoSaida(String DataDebSaida){
        click(dataDebitoSaidas); sendKeys(dataDebitoSaidas, DataDebSaida);
    }

    public void clicarContaContabil(){
        click(FiltroContaContabil); click(ContaContabil);
    }

    public void clicarEstabelecimento(){
        click(FiltroEstabelecimento); click(Estabelecimento);
    }

    public void preencherNrRecibo(String NumRecibo){
        click(NrRecibo); sendKeys(NrRecibo, NumRecibo);
    }

    public void clicarAbaApuracaoDeImposto(){
        click(AbaApuracaoDeImposto);
    }

}