package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.AgenciaFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.flows.AgenciaFlows;
import com.javaseleniumtemplate.pages.AgenciaPage;
import com.javaseleniumtemplate.pages.LoginPage;
import com.javaseleniumtemplate.pages.MainPage;
import com.javaseleniumtemplate.pages.AgenciaPage;
import org.testng.Assert;
import org.testng.annotations.Test;

public class Agencia extends TestBase {

    // Objetos

    MainPage mainPage;
    LoginPage loginPage;
    MainFlows MainFlows;
    com.javaseleniumtemplate.flows.AgenciaFlows AgenciaFlows;
    com.javaseleniumtemplate.pages.AgenciaPage AgenciaPage;

    // Teste

    @Test
    public void efetuarLoginComSucesso() throws InterruptedException {

        //Objetos Instanciados

        mainPage = new MainPage();
        loginPage = new LoginPage();
        MainFlows = new MainFlows();
        AgenciaFlows = new AgenciaFlows();
        AgenciaPage = new AgenciaPage();

        // Dados - Login

        String Usuario = "operador24@AUTOMACAO_2184.com";
        String Senha = "apresentacao";

        String Agencia = "Agência";
        String NumeroCDAGENCIA = "12345";
        String NomeNMAGENCIA = "Agencia Teste ";
        String NumeroNRCGCAGEN = "34.832.531/0001-62";
        String CepNumeroNRCGCAGEN = "34006003";
        String Telefone = "31982150000";
        String Fax = "31982150000";

        loginPage.preenhcerUsuario(Usuario);
        loginPage.preencherSenha(Senha);
        loginPage.clicarEmLogin();

        // Aguardar Botão de Confirmação(Alerta: Sim)
        AgenciaPage.AlertaUsuario();

        //Navegar até o Banco
        AgenciaPage.NavegarParaAgencia(Agencia);

        //Filtro
        AgenciaPage.Filtro();

        //Adicionar Agência
        AgenciaPage.AdicionarAgencia(NumeroCDAGENCIA, NomeNMAGENCIA, NumeroNRCGCAGEN, CepNumeroNRCGCAGEN, Telefone, Fax);

    }
}