package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.ParametrosTituloPagarFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.flows.ParametrosTituloPagarFlows;
import com.javaseleniumtemplate.pages.ParametrosTituloPagarPage;
import com.javaseleniumtemplate.pages.LoginPage;
import com.javaseleniumtemplate.pages.MainPage;
import com.javaseleniumtemplate.pages.ParametrosTituloPagarPage;
import org.testng.Assert;
import org.testng.annotations.Test;

public class ParametrosTituloPagar extends TestBase {

    // Objetos

    MainPage mainPage;
    LoginPage loginPage;
    MainFlows MainFlows;
    com.javaseleniumtemplate.flows.ParametrosTituloPagarFlows ParametrosTituloPagarFlows;
    com.javaseleniumtemplate.pages.ParametrosTituloPagarPage ParametrosTituloPagarPage;

    // Teste

    @Test
    public void efetuarLoginComSucesso() throws InterruptedException {

        //Objetos Instanciados

        mainPage = new MainPage();
        loginPage = new LoginPage();
        MainFlows = new MainFlows();
        ParametrosTituloPagarFlows = new ParametrosTituloPagarFlows();
        ParametrosTituloPagarPage = new ParametrosTituloPagarPage();

        // Dados - Login

        String Usuario = "operador24@AUTOMACAO_2184.com";
        String Senha = "apresentacao";


        loginPage.preenhcerUsuario(Usuario);
        loginPage.preencherSenha(Senha);
        loginPage.clicarEmLogin();

        String ValorQuantidadeDeDiasAnterioresADataDeProcessamento = "5";
        String ValorQuantidadeDeDiasPosterioresADataDeProcessamento = "8";
        String ValorQuantidadeDeDiasAnterioresADataDeProcessamento2 = "5";
        String ValorQuantidadeDeDiasPosterioresADataDeProcessamento2 = "7";
        String ValorQuantidadeDeDiasAnterioresADataDeProcessamento3 = "5";
        String ValorQuantidadeDeDiasPosterioresADataDeProcessamento3 = "6";

        // Aguardar Botão de Confirmação(Alerta: Sim)
        ParametrosTituloPagarPage.AlertaUsuario();


        // Navegar até Parâmetros de Títulos a Pagar
        MainFlows.EntrarMenu();

       // Aguardar Botão de Confirmação(Alerta: Sim)
        ParametrosTituloPagarPage.navegarParaParametroFinanceiro();

        ParametrosTituloPagarPage.EditarFinanceiroAbaOperacional();

        ParametrosTituloPagarPage.EditarFinanceiroAbaIntervaloDeDatas(ValorQuantidadeDeDiasAnterioresADataDeProcessamento, ValorQuantidadeDeDiasPosterioresADataDeProcessamento,ValorQuantidadeDeDiasAnterioresADataDeProcessamento2, ValorQuantidadeDeDiasPosterioresADataDeProcessamento2,ValorQuantidadeDeDiasAnterioresADataDeProcessamento3, ValorQuantidadeDeDiasPosterioresADataDeProcessamento3);

        ParametrosTituloPagarPage.GrupoDeOperadores();

    }
}